=== debian/changelog ===
amdsmi (7.2.0-1ubuntu1) resolute; urgency=medium

  * d/p/0005-fix-compilation-against-newer-libdrm.patch:
    Thanks to Mario Limonciello (Closes: #1127498) (LP: #2140490)
  * d/p/0006-Remove-some-unnecessary-header-includes-and-adjust-o.patch
  * d/libamd-smi26.shlibs: adding shlibs to make maintenance easier.
    There are a lot of c++ symbols exposed, making things harder to track
    and producing false negatives for this library.

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Tue, 24 Feb 2026 23:31:57 +0100

amdsmi (7.2.0-1) unstable; urgency=medium

  * New upstream version.
  * refresh patches

 -- Mario Limonciello <superm1@debian.org>  Thu, 22 Jan 2026 15:50:29 -0600
