=== debian/control ===
Source: amdsmi
Section: devel
Homepage: https://github.com/ROCm/amdsmi
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Xuanteng Huang <xuanteng.huang@outlook.com>,
           Mario Limonciello <superm1@debian.org>,
           Cordell Bloor <cgmb@slerp.xyz>
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/rocm-team/amdsmi
Vcs-Git: https://salsa.debian.org/rocm-team/amdsmi.git
Rules-Requires-Root: no
XBSC-Comment: amd-smi looks for libamd_smi.so, so it depends on the -dev package
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               libdrm-dev,
               help2man,
               txt2man,
               python3-yaml,
               libgtest-dev <!nocheck>,

Package: amd-smi
Architecture: amd64
Section: utils
Depends: ${misc:Depends},
         libamd-smi-dev (= ${binary:Version}),
         python3,
         python3-yaml,
         python3-argcomplete,
Description: AMD System Management Interface - executable
 amdsmi (AMD System Management Interface Library) is a C library for
 Linux providing user space interfaces to monitor and control AMD GPU devices.
 .
 This package provides the amd-smi executable.

Package: libamd-smi26
Architecture: amd64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libdrm-dev,
Description: AMD System Management Interface - library
 amdsmi (AMD System Management Interface Library) is a C library for
 Linux providing user space interfaces to monitor and control AMD GPU devices.
 .
 This package provides the amdsmi library.

Package: libamd-smi-dev
Architecture: amd64
Section: libdevel
Depends: libamd-smi26 (= ${binary:Version}),
         ${misc:Depends},
Description: AMD System Management Interface - headers
 amdsmi (AMD System Management Interface Library) is a C library for
 Linux providing user space interfaces to monitor and control AMD GPU devices.
 .
 This package provides the amdsmi headers.

Package: libgoamdsmi-shim64-1
Architecture: amd64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libdrm-dev,
Description: AMD System Management Interface - go library
 goamdsmi_shim (AMD System Management Interface Library) is a C library for
 Linux providing user space interfaces to monitor and control AMD GPU devices.
 .
 This package provides the go library for amdsmi_shim.

Package: libgoamdsmi-shim64-dev
Architecture: amd64
Section: libdevel
Depends: libgoamdsmi-shim64-1 (= ${binary:Version}),
         ${misc:Depends},
Description: AMD System Management Interface - go headers
 goamdsmi_shim (AMD System Management Interface Library) is a C library for
 Linux providing user space interfaces to monitor and control AMD GPU devices.
 .
 This package provides the go headers for amdsmi_shim.

# Package: libamd-smi26-tests
# Build-Profiles: <!nocheck>
# Architecture: amd64
# Section: libdevel
# Depends: libamd-smi-dev (= ${binary:Version}),
#          ${misc:Depends},
#          ${shlibs:Depends},
# Description: AMD System Management Interface - tests
#  amdsmi (AMD System Management Interface Library) is a C library for
#  Linux providing user space interfaces to monitor and control AMD GPU devices.
#  .
#  This package provides the amdsmi test cases.
